Bug 1996162 - opm may prune bundles from the input
Summary: opm may prune bundles from the input
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: OpenShift Container Platform
Classification: Red Hat
Component: OLM
Version: 4.9
Hardware: Unspecified
OS: Unspecified
high
high
Target Milestone: ---
: 4.8.z
Assignee: Ankita Thomas
QA Contact: xzha
URL:
Whiteboard:
Depends On: 1983673
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-08-20 17:59 UTC by OpenShift BugZilla Robot
Modified: 2021-10-19 20:35 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2021-10-19 20:35:31 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Private Priority Status Summary Last Updated
Github openshift operator-framework-olm pull 165 0 None None None 2021-08-20 18:01:03 UTC
Red Hat Product Errata RHBA-2021:3821 0 None None None 2021-10-19 20:35:46 UTC

Comment 1 xzha 2021-09-22 09:35:28 UTC
verify:
zhaoxia@xzha-mac operator-framework-olm % ./bin/opm version        
Version: version.Version{OpmVersion:"ce87d28dd", GitCommit:"ce87d28ddb336158bfd335e78bf9701679c3abf9", BuildDate:"2021-09-22T09:22:53Z", GoOs:"darwin", GoArch:"amd64"}


zhaoxia@xzha-mac operator-framework-olm % ./bin/opm index add -b quay.io/olmqe/ditto-operator:1983673-0.1.2 -f quay.io/olmqe/ditto-index:1983673-1 -t quay.io/olmqe/ditto-index:1983673-2 -c docker
INFO[0000] building the index                            bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0000] Pulling previous image quay.io/olmqe/ditto-index:1983673-1 to get metadata  bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0000] running /usr/local/bin/docker pull quay.io/olmqe/ditto-index:1983673-1  bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0004] running /usr/local/bin/docker pull quay.io/olmqe/ditto-index:1983673-1  bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0008] Getting label data from previous image        bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0008] running docker inspect                        bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0008] running docker create                         bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0008] running docker cp                             bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0010] running docker rm                             bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0010] running /usr/local/bin/docker pull quay.io/olmqe/ditto-operator:1983673-0.1.2  bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0014] running docker create                         bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0015] running docker cp                             bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0015] running docker rm                             bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0015] Could not find optional dependencies file     dir=bundle_tmp374267269 file=bundle_tmp374267269/metadata load=annotations
INFO[0015] found csv, loading bundle                     dir=bundle_tmp374267269 file=bundle_tmp374267269/manifests load=bundle
INFO[0015] loading bundle file                           dir=bundle_tmp374267269/manifests file=ditto-operator.v0.2.0.clusterserviceversion.yaml load=bundle
INFO[0015] loading bundle file                           dir=bundle_tmp374267269/manifests file=ditto.yaml load=bundle
INFO[0015] Could not find optional dependencies file     dir=bundle_tmp374267269 file=bundle_tmp374267269/metadata load=annotations
INFO[0015] found csv, loading bundle                     dir=bundle_tmp374267269 file=bundle_tmp374267269/manifests load=bundle
INFO[0015] loading bundle file                           dir=bundle_tmp374267269/manifests file=ditto-operator.v0.2.0.clusterserviceversion.yaml load=bundle
INFO[0015] loading bundle file                           dir=bundle_tmp374267269/manifests file=ditto.yaml load=bundle
ERRO[0015] permissive mode disabled                      bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]" error="added bundle quay.io/olmqe/ditto-operator:1983673-0.1.2 pruned from package ditto-operator, channel alpha: this may be due to incorrect channel head (ditto-operator.v0.2.0)"
Error: added bundle quay.io/olmqe/ditto-operator:1983673-0.1.2 pruned from package ditto-operator, channel alpha: this may be due to incorrect channel head (ditto-operator.v0.2.0)
Usage:
  opm index add [flags]

Examples:
  # Create an index image from scratch with a single bundle image
  opm index add --bundles quay.io/operator-framework/operator-bundle-prometheus@sha256:a3ee653ffa8a0d2bbb2fabb150a94da6e878b6e9eb07defd40dc884effde11a0 --tag quay.io/operator-framework/monitoring:1.0.0
  
  # Add a single bundle image to an index image
  opm index add --bundles quay.io/operator-framework/operator-bundle-prometheus:0.15.0 --from-index quay.io/operator-framework/monitoring:1.0.0 --tag quay.io/operator-framework/monitoring:1.0.1
  
  # Add multiple bundles to an index and generate a Dockerfile instead of an image
  opm index add --bundles quay.io/operator-framework/operator-bundle-prometheus:0.15.0,quay.io/operator-framework/operator-bundle-prometheus:0.22.2 --generate

Flags:
  -i, --binary-image opm        container image for on-image opm command
  -u, --build-tool string       tool to build container images. One of: [docker, podman]. Defaults to podman. Overrides part of container-tool.
  -b, --bundles strings         comma separated list of bundles to add
  -c, --container-tool string   tool to interact with container images (save, build, etc.). One of: [docker, podman]
  -f, --from-index string       previous index to add to
      --generate                if enabled, just creates the dockerfile and saves it to local disk
  -h, --help                    help for add
      --mode string             graph update mode that defines how channel graphs are updated. One of: [replaces, semver, semver-skippatch] (default "replaces")
  -d, --out-dockerfile string   if generating the dockerfile, this flag is used to (optionally) specify a dockerfile name
      --permissive              allow registry load errors
  -p, --pull-tool string        tool to pull container images. One of: [none, docker, podman]. Defaults to none. Overrides part of container-tool.
  -t, --tag string              custom tag for container image being built

Global Flags:
      --skip-tls   skip TLS certificate verification for container image registries while pulling bundles or index

LGTM, verified.

Comment 5 xzha 2021-10-09 01:51:54 UTC
zhaoxia@xzha-mac operator-framework-olm % bin/opm version
Version: version.Version{OpmVersion:"5649248e3", GitCommit:"5649248e3d41134d2f0af130b5d00bcd588e7d3d", BuildDate:"2021-10-09T01:45:11Z", GoOs:"darwin", GoArch:"amd64"}
zhaoxia@xzha-mac operator-framework-olm % ./bin/opm index add -b quay.io/olmqe/ditto-operator:1983673-0.1.2 -f quay.io/olmqe/ditto-index:1983673-1 -t quay.io/olmqe/ditto-index:1983673-2 -c docker
INFO[0000] building the index                            bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0000] Pulling previous image quay.io/olmqe/ditto-index:1983673-1 to get metadata  bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0000] running /usr/local/bin/docker pull quay.io/olmqe/ditto-index:1983673-1  bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0005] running /usr/local/bin/docker pull quay.io/olmqe/ditto-index:1983673-1  bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0009] Getting label data from previous image        bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0009] running docker inspect                        bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0009] running docker create                         bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0010] running docker cp                             bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0012] running docker rm                             bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0013] running /usr/local/bin/docker pull quay.io/olmqe/ditto-operator:1983673-0.1.2  bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0017] running docker create                         bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0017] running docker cp                             bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0018] running docker rm                             bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]"
INFO[0018] Could not find optional dependencies file     dir=bundle_tmp612039648 file=bundle_tmp612039648/metadata load=annotations
INFO[0018] found csv, loading bundle                     dir=bundle_tmp612039648 file=bundle_tmp612039648/manifests load=bundle
INFO[0018] loading bundle file                           dir=bundle_tmp612039648/manifests file=ditto-operator.v0.2.0.clusterserviceversion.yaml load=bundle
INFO[0018] loading bundle file                           dir=bundle_tmp612039648/manifests file=ditto.yaml load=bundle
INFO[0018] Could not find optional dependencies file     dir=bundle_tmp612039648 file=bundle_tmp612039648/metadata load=annotations
INFO[0018] found csv, loading bundle                     dir=bundle_tmp612039648 file=bundle_tmp612039648/manifests load=bundle
INFO[0018] loading bundle file                           dir=bundle_tmp612039648/manifests file=ditto-operator.v0.2.0.clusterserviceversion.yaml load=bundle
INFO[0018] loading bundle file                           dir=bundle_tmp612039648/manifests file=ditto.yaml load=bundle
ERRO[0018] permissive mode disabled                      bundles="[quay.io/olmqe/ditto-operator:1983673-0.1.2]" error="added bundle quay.io/olmqe/ditto-operator:1983673-0.1.2 pruned from package ditto-operator, channel alpha: this may be due to incorrect channel head (ditto-operator.v0.2.0)"
Error: added bundle quay.io/olmqe/ditto-operator:1983673-0.1.2 pruned from package ditto-operator, channel alpha: this may be due to incorrect channel head (ditto-operator.v0.2.0)
Usage:
  opm index add [flags]

Examples:
  # Create an index image from scratch with a single bundle image
  opm index add --bundles quay.io/operator-framework/operator-bundle-prometheus@sha256:a3ee653ffa8a0d2bbb2fabb150a94da6e878b6e9eb07defd40dc884effde11a0 --tag quay.io/operator-framework/monitoring:1.0.0
  
  # Add a single bundle image to an index image
  opm index add --bundles quay.io/operator-framework/operator-bundle-prometheus:0.15.0 --from-index quay.io/operator-framework/monitoring:1.0.0 --tag quay.io/operator-framework/monitoring:1.0.1
  
  # Add multiple bundles to an index and generate a Dockerfile instead of an image
  opm index add --bundles quay.io/operator-framework/operator-bundle-prometheus:0.15.0,quay.io/operator-framework/operator-bundle-prometheus:0.22.2 --generate

Flags:
  -i, --binary-image opm        container image for on-image opm command
  -u, --build-tool string       tool to build container images. One of: [docker, podman]. Defaults to podman. Overrides part of container-tool.
  -b, --bundles strings         comma separated list of bundles to add
  -c, --container-tool string   tool to interact with container images (save, build, etc.). One of: [docker, podman]
  -f, --from-index string       previous index to add to
      --generate                if enabled, just creates the dockerfile and saves it to local disk
  -h, --help                    help for add
      --mode string             graph update mode that defines how channel graphs are updated. One of: [replaces, semver, semver-skippatch] (default "replaces")
  -d, --out-dockerfile string   if generating the dockerfile, this flag is used to (optionally) specify a dockerfile name
      --permissive              allow registry load errors
  -p, --pull-tool string        tool to pull container images. One of: [none, docker, podman]. Defaults to none. Overrides part of container-tool.
  -t, --tag string              custom tag for container image being built

Global Flags:
      --skip-tls   skip TLS certificate verification for container image registries while pulling bundles or index

LGTM, verified

Comment 8 errata-xmlrpc 2021-10-19 20:35:31 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory (OpenShift Container Platform 4.8.15 bug fix update), and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

https://access.redhat.com/errata/RHBA-2021:3821


Note You need to log in before you can comment on or make changes to this bug.